import { SegmentEvent } from '../events';
/**
 * Augments a segment event with information about the current page.
 * Page information like URL changes frequently, so this is meant to be captured as close to the event call as possible.
 * Things like `userAgent` do not change, so they can be added later in the flow.
 * We prefer not to add this information to this function, as it increases the main bundle size.
 */
export declare const addPageContext: (event: SegmentEvent, pageCtx?: import("@segment/analytics-page-tools").PageContext) => void;
//# sourceMappingURL=add-page-context.d.ts.map