import { Analytics } from '../../core/analytics';
import { CDNSettings } from '../../browser';
import { Plugin } from '../../core/plugin';
import { DeliveryStrategy } from './shared-dispatcher';
export type SegmentioSettings = {
    apiKey: string;
    apiHost?: string;
    protocol?: 'http' | 'https';
    addBundledMetadata?: boolean;
    unbundledIntegrations?: string[];
    bundledConfigIds?: string[];
    unbundledConfigIds?: string[];
    maybeBundledConfigIds?: Record<string, string[]>;
    deliveryStrategy?: DeliveryStrategy;
};
export type SegmentIOPluginMetadata = {
    writeKey: string;
    apiHost: string;
    protocol: string;
};
export interface SegmentIOPlugin extends Plugin {
    metadata: SegmentIOPluginMetadata;
}
export declare const isSegmentPlugin: (plugin: Plugin) => plugin is SegmentIOPlugin;
export declare function segmentio(analytics: Analytics, settings?: SegmentioSettings, integrations?: CDNSettings['integrations']): Plugin;
//# sourceMappingURL=index.d.ts.map